/* ===================================================================
 * DeleteUserForm.java
 * 
 * Created Nov 18, 2004 10:44:18 PM
 * 
 * Copyright (c) 2004 Matt Magoffin (spamsqr@msqr.us)
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of 
 * the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 
 * 02111-1307 USA
 * ===================================================================
 * $Id: DeleteUserForm.java 28 2009-05-04 01:19:45Z msqr $
 * ===================================================================
 */

package magoffin.matt.ieat.web;

import java.util.LinkedHashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import magoffin.matt.ieat.biz.BizContext;
import magoffin.matt.ieat.domain.UiSearchResults;
import magoffin.matt.ieat.domain.User;
import magoffin.matt.ieat.util.UserCommand;

import org.springframework.validation.BindException;
import org.springframework.validation.Errors;
import org.springframework.web.servlet.ModelAndView;

/**
 * Form controller to delete a User.
 * 
 * @author Matt Magoffin (spamsqr@msqr.us)
 * @version $Revision: 28 $ $Date: 2009-05-04 13:19:45 +1200 (Mon, 04 May 2009) $
 */
public class DeleteUserForm extends AbstractEatForm {
	
	@SuppressWarnings("unchecked")
	@Override
	protected Map referenceData(HttpServletRequest request, Object command,
			Errors errors) throws Exception {
		Map<String, Object> m = new LinkedHashMap<String, Object>();
		
		UiSearchResults sr = getDomainObjectFactory().getSearchResultsInstance();
		m.put("uidata",sr);

		// add user
		UserCommand uc = (UserCommand)command;
		BizContext context = WebUtil.getAdminBizContext(request,userBiz);
		User u = userBiz.getUserById(uc.getUserId(),context);
		sr.getUser().add(u);
		
		WebUtil.initSearchResults(sr,uc.getIndex(),null, getDomainObjectFactory());
		
		return m;
	}
	
	@Override
	protected ModelAndView onSubmit(HttpServletRequest request,
			HttpServletResponse response, Object command, BindException errors)
			throws Exception {
		UserCommand userCommand = (UserCommand)command;
		
		Map<String, Object> m = new LinkedHashMap<String, Object>();
		WebUtil.saveUserCommand(m,userCommand);
		
		BizContext context = WebUtil.getAdminBizContext(request, userBiz);
		userBiz.removeUser(userCommand.getUserId(),context);
		
		return new ModelAndView(getSuccessView(),m);
	}

	@Override
	protected ModelAndView processCancel(HttpServletRequest request,
			HttpServletResponse response, Object command, BindException errors) {
		UserCommand userCommand = (UserCommand)command;
		Map<String, Object> model = new LinkedHashMap<String, Object>();
		WebUtil.saveUserCommand(model,userCommand);
		return new ModelAndView(getCancelView(),model);
	}
	
}
